package com.lantone.qc.trans.beilun.util;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.pub.util.StringUtil;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: rengb
 * @time: 2020/9/28 16:36
 */
public class BeiLunOperationRecordHtmlAnalysis implements BeiLunHtmlAnalysis {

    private String modeId = "17";

    @Override
    public Map<String, String> analysis(String... args) {
        Map<String, String> map = Maps.newLinkedHashMap();
        String html = args[0];
        String recTitle = args[1];
        String recTypeId = args[2];
        Element bigDivElement = Jsoup.parse(html).selectFirst("body").child(0);
        analysisGeneral(bigDivElement, map);
        BeiLunHtmlAnalysisUtil.mapValueRemoveStartColon(map);
        if (map.containsKey("手术人员")) {
            String operatingCrew = map.get("手术人员");
            if (StringUtil.isNotBlank(operatingCrew)) {
                CommonAnalysisUtil.cutByTitles(operatingCrew, Lists.newArrayList("主刀", "一助", "二助", "洗手护士"), 0, map);
            }
        }
        BeiLunHtmlAnalysisUtil.insertModuleId(modeId, recTypeId, map);
        return map;
    }

    private void analysisGeneral(Element bigDivElement, Map<String, String> map) {
        if (bigDivElement.selectFirst("hr") != null) {
            bigDivElement.selectFirst("hr").previousElementSiblings().remove();
        }
        String text = BeiLunHtmlAnalysisUtil.blockDivToStr(bigDivElement, true);
        text = text.replaceAll("第1页", "");
        List<String> titles = Lists.newArrayList(
                "手术时间", "手术日期", "术前诊断", "手术指征", "手术人员", "麻醉方式", "麻醉人员", "接生者",
                "术前胎心", "手术名称", "术后诊断", "手术者及助手名称", "术中取病理标本", "麻醉方法", "麻 醉 者", "手术经过",
                "医生签名", "记录时间", "时间", "记录者", "术中输血", "术前宫颈准备日期", "药物名称及用法", "导管或其他", "插入深度",
                "阴道填塞纱布条", "准备者", "取出日期", "手术方法", "术中特殊情况", "病理检查", "其他", "记录者", "手术者",
                "检查子宫位置"
        );
        titles = CommonAnalysisUtil.sortTitlesNoColon(titles, text);
        CommonAnalysisUtil.cutByTitlesNoColon(text, titles, 0, map);
    }

}